Package com.creditcall.chipdnamobile

# Interface ITransactionFinishedListener

public interface ITransactionFinishedListener
This interface is used to receive notification of the result after calling method `ChipDnaMobile.startTransaction(Parameters)`.

Register listener using `ChipDnaMobile.addTransactionFinishedListener(ITransactionFinishedListener)`.

Author:
  Creditcall Ltd

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `onTransactionFinishedListener(Parameters parameters)`
  Invoked after transaction processing is finished.

- ## Method Details

  - ### onTransactionFinishedListener

    void onTransactionFinishedListener(Parameters parameters)
    Invoked after transaction processing is finished.
    Parameters:
      `parameters` - `Parameters` collection which can contain:

      `ParameterKeys.AcquirerResponseCode` The acquirer response code.

      `ParameterKeys.Amount` Amount in minor units e.g. "123" for GBP1.23.

      `ParameterKeys.AmountOnlineAuthorized` The amount authorized online, in minor units e.g. "123" for GBP1.23.

      `ParameterKeys.AuthCode` Alpha numeric authorization code, up to 12 characters.

      `ParameterKeys.CardEaseReference` Unique GUID generated for a transaction if the authorization was submitted online to the NMI payment platform.

      `ParameterKeys.CardHashCollection` list of tokens generated by NMI payment gateway and or payment device that can be used to identify a card without the PAN. Value in XML format representing List of `CardHash`, deserialize into object using `ChipDnaMobileSerializer.deserializeCardHashes(String)`.

      `ParameterKeys.CardReference` The unique reference generated by the NMI payment gateway that can be used to identify a card without using the PAN.

      `ParameterKeys.CardSchemeId` The `CardSchemeIdEnum`.

      `ParameterKeys.Currency` The 3-char currency code.

      `ParameterKeys.MaskedPan` Masked primary account number showing only the first 6 (if available) and last 4 digits.

      `ParameterKeys.PaymentMethod` The payment method; `ParameterValues.Card`, `ParameterValues.Cash`, or `ParameterValues.Cheque`.

      `ParameterKeys.PreformattedCustomerReceipt` Preformatted receipt text, customer copy.

      `ParameterKeys.PreformattedMerchantReceipt` Preformatted receipt text, merchant copy.

      `ParameterKeys.ReceiptData` serialized receipt data in XML format. The data can be deserialized into an NSDictionary using `ChipDnaMobileSerializer.deserializeReceiptData(String)`. The deserialized NSDictionary will have the string `ChipDnaMobileSerializer.ReceiptItemTag` as keys and `ReceiptField` objects as values.

      `ParameterKeys.UserReference` Unique reference of the transaction supplied by the integrating application.

      `ParameterKeys.TransactionDateTime` Local date and time of the transaction.

      `ParameterKeys.TransactionDateTimeUtc` UTC date and time of the transaction.

      `ParameterKeys.DateTimeFormat` Format of the date and time in `ParameterKeys.TransactionDateTime` or `ParameterKeys.TransactionDateTimeUtc`.

      `ParameterKeys.TransactionResult` The result of the transaction authorization. Can be `ParameterValues.Approved`, `ParameterValues.PartiallyApproved` or `ParameterValues.Declined`.

      `ParameterKeys.TransactionState` Transaction state. Value can be `ParameterValues.Uncommitted`, `ParameterValues.Voided` or , `ParameterValues.UncommittedVoid`.

      `ParameterKeys.TransactionType` The transaction type. `ParameterValues.Sale`, `ParameterValues.Refund` or `ParameterValues.AccountVerification`.

      `ParameterKeys.MerchantName` Merchant name is returned for Cash and Cheque transactions.

      `ParameterKeys.CustomerVaultId` The identifier for the customer's vault.

      `ParameterKeys.TransactionId` The identifier for transactions using the payment gateway.

      `ParameterKeys.Errors` Comma separated errors encountered during transaction processing.

      `ParameterKeys.Par` Payment Account Reference, alpha numeric reference that is 29 characters in length.

      `ParameterKeys.EncodedRequest` Delayed online processing payload returned as an encoded request.

      `ParameterKeys.CardTokens` List of card tokens generated by NMI payment gateway. Value in XML format representing a list of `CardToken`, deserialize into object using `ChipDnaMobileSerializer.deserializeCardTokens(String)`.